#pragma once

#include <iostream>
#include <vector>

struct BoundaryFiniteElement {
  BoundaryFiniteElement(int id, int surfaceId, std::vector<int> nodesId)
      : id(id), surfaceId(surfaceId), nodesId(std::move(nodesId)) {}

  int id;
  int surfaceId;
  std::vector<int> nodesId;

  friend bool operator==(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2);
  friend bool operator<(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2);
  friend bool operator>(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2);
  friend bool operator<=(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2);
  friend bool operator>=(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2);
  friend bool operator!=(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2);
  friend std::ostream &operator<<(std::ostream &out, const BoundaryFiniteElement &element);
};

void PrintBoundaryFiniteElement(const BoundaryFiniteElement &elem);

