#pragma once

#include <vector>
#include <iostream>

struct FiniteElement {
  FiniteElement(int id, int materialId, std::vector<int> nodesId)
      : id(id), materialId(materialId), nodesId(std::move(nodesId)) {}

  int id;
  int materialId;
  std::vector<int> nodesId;

  bool operator==(const FiniteElement &elem) const;
  bool operator<(const FiniteElement &elem) const;
  friend std::ostream &operator<<(std::ostream &out, const FiniteElement &element);
};

void PrintFiniteElement(const FiniteElement& elem);