#pragma once

#include <utility>
#include <vector>
#include <fstream>
#include <iostream>

struct Node {
  Node(int id, std::vector<float> coordinates, bool isElementVertice)
      : id(id), coordinates(std::move(coordinates)), isElementVertice(isElementVertice) {}
  int id;
  std::vector<float> coordinates;
  bool isElementVertice;

  bool operator==(const Node &node) const;
  bool operator<(const Node &node) const;
  friend std::ostream &operator<<(std::ostream &out, const Node &node);
};

void PrintNode(const Node& elem);