#include "MeshLoaders/AneuMeshLoader.h"
#include "MeshLoaders/NeuMeshLoader.h"
#include <iostream>

namespace std {
std::ostream &operator<<(std::ostream &out, const std::vector<int> &rec) {
  for (const auto &i: rec) {
    out << i;
  }

  return out;
}
}

int main(int argc, char **argv) {
  AneuMeshLoader loader;
  //loader.LoadMesh(argv[1]);
  loader.LoadMesh("../test.aneu");
  auto result1 = loader.GetFiniteElementsByNodesId(66, 65, 324);
  std::ranges::for_each(result1, [](const int &elemId) { std::cout << elemId << ' '; });
  std::cout << std::endl;
  std::cout << std::endl;

  result1 = loader.GetFiniteElementsByEdge(65, 66);
  //std::cout << result1;
  std::ranges::for_each(result1, [](const int &elemId) { std::cout << elemId << ' '; });
  std::cout << std::endl;
  std::cout << std::endl;

  result1 = loader.GetBboundaryFiniteElementsBySurfaceId(1);
  std::ranges::for_each(result1, [](const int &elemId) { std::cout << elemId << ' '; });
  std::cout << std::endl;
  std::cout << std::endl;

  result1 = loader.GetFiniteElementsByMaterialId(1);
  std::ranges::for_each(result1, [](const int &elemId) { std::cout << elemId << ' '; });
  std::cout << std::endl;
  std::cout << std::endl;

  auto allBoundary = loader.GetBoundaryFiniteElements();
  loader.SortByMinAngle();

  std::ofstream outputStream("result.txt", std::ios::out);

  auto indexasion = [](const BoundaryFiniteElement &elem) {
    return elem.nodesId;
  };

  auto outputResult = allBoundary | std::ranges::views::transform(indexasion)
      | std::ranges::views::drop(10)
      | std::ranges::views::take(10);

  std::ranges::copy(outputResult, std::ostream_iterator<std::vector<int>>(outputStream, "\t"));

  return 0;
}
