#include "GeometryStructures/BoundaryFiniteElement.h"

std::ostream &operator<<(std::ostream &out, const BoundaryFiniteElement &elem) {
  out << "Boundary element: " << elem.id
      << " Surface id: " << elem.surfaceId
      << "Nodes id list: ";
  for (const auto &index: elem.nodesId) {
    out << index << ' ';
  }

  return out;
}
bool operator==(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2) {
  return (e1 <= e2 || e2 <= e1);
}
bool operator<(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2) {
  if (e1.id < e2.id) {
    return true;
  }

  if (e1.id == e2.id && e1.surfaceId < e2.surfaceId) {
    return true;
  }

  if (e1.id == e2.id && e1.surfaceId == e2.surfaceId && e1.nodesId < e2.nodesId) {
    return true;
  }

  return false;
}
bool operator>(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2) {
  return e2 < e1;
}
bool operator<=(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2) {
  return !(e2 < e1);
}
bool operator>=(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2) {
  return !(e1 < e2);
}
bool operator!=(const BoundaryFiniteElement &e1, const BoundaryFiniteElement &e2) {
  return (e1 < e2 && e2 < e1);
}

void PrintBoundaryFiniteElement(const BoundaryFiniteElement &elem) { std::cout << elem; }