#include "MeshLoaders/NeuMeshLoader.h"

void NeuMeshLoader::LoadMesh(const std::string &filename) {
  std::ifstream meshFile(filename, std::ios::in);
  if (!meshFile) {

  }

  std::cout << "File \"" << filename << "\" status: opened" << std::endl;
  std::cout << "Loading..." << std::endl;

  int nodesCount, dimentionCount = 3;
  meshFile >> nodesCount;
  for (int i = 1; i <= nodesCount; ++i) {
    int id = i;
    std::vector<float> coordinates(dimentionCount);
    for (int j = 1; j <= dimentionCount; ++j) {
      meshFile >> coordinates[j - 1];
    }
    nodes.emplace_back(id, coordinates, true);
  }

  dimentionCount = 4;
  meshFile >> nodesCount;
  for (int i = 1; i <= nodesCount; ++i) {
    int id = i;
    std::vector<int> coordinates(dimentionCount);
    int materialId;
    meshFile >> materialId;
    for (int j = 1; j <= dimentionCount; ++j) {
      meshFile >> coordinates[j - 1];
    }
    finiteElements.emplace_back(id, materialId, coordinates);
  }

  dimentionCount = 3;
  meshFile >> nodesCount;
  for (int i = 1; i <= nodesCount; ++i) {
    int id = i;
    std::vector<int> coordinates(dimentionCount);
    int materialId;
    meshFile >> materialId;
    for (int j = 1; j <= dimentionCount; ++j) {
      meshFile >> coordinates[j - 1];
    }
    boundaryFiniteElements.emplace_back(id, materialId, coordinates);
  }

  meshFile.close();
  std::cout << "Neu file import was successful" << std::endl;
}